Subject: Re: git svn and SVN property svn:original-date

From: Eric Wong <[email-masked]>
Date: Thu, 23 Mar 2017 17:31:56 +0000

Craig McQueen <[email-masked]> wrote:
> Eric Wong wrote:
> > Craig McQueen <[email-masked]> wrote:
> > > Apparently SVN revisions can have an "svn:original-date" property, which
> > would be good to set on dcommit, to preserve the timestamp from the git
> > repository.
> > >
> > >
> > https://subversion.apache.org/docs/api/1.7/group__svn__props__revision
> > > __props.html#ga8f17351dd056149da9cb490f1daf4018
> > 
> > Any idea if which versions of SVN it's supported in and how recent the
> > feature is?
> 
> I see discussion about it in 2003, so I guess it's been there right from 1.0.0.
> 
> > Perhaps we can enable it everywhere, and maybe only old clients won't
> > understand it, but won't fail; and we could start using it as the author date
> > with "git svn fetch".
> 
> Using it for author date sounds sensible.

OK, I'd be inclined to accept a patch + tests for that;
my plate might be full with non-git stuff until April.

> > OTOH, that would break the (perhaps unofficial) independently-created-git-
> > svn-mirrors-should-have-same-oids-by-default
> > rule when people run different versions of git, so maybe it could be an
> > option...
> 
> Hmm, good question. Maybe it should be an option, though I
> hope it would be enabled by default (since the feature would
> be more metadata-preserving, which is a good thing), with an
> option to disable it to allow backwards compatibility with
> people running an older version of git. That's my opinion
> anyway, and I realise my opinion is not necessarily
> well-informed regarding all considerations.

Given git-svn behavior hasn't changed much in over a decade, I'd
rather be conservative with regards to changing any existing
behavior.  We could offer one warning about it to inform users
about it if original-date is seen, however.

> Note, I'm unclear as to whether Subversion is willing to store
> timezone information in svn:original-date. But I guess having
> git author date correspond to svn:original-date is an
> improvement for preserving more metadata, even if the timezone
> is lost in the process.

Can you find any examples of it in the wild?  I prefer having
real-world examples to look at.  Thanks.